;FILENAME: DOLISP.LSP
;DEVELOPED BY: Perry H. Mason                                     Date: 11/20/89
;              Industrial TurnAround Corp.
;              922 E. Randolph Rd.
;              Hopewell, VA. 23860
;              Work #: (804) 541-8714
;              Fax #:  (804) 541-0751
;              Home #: (804) 732-6432
;
;Use: Create an AutoLISP routine from AutoCAD drawing.
;
(setq OLDECHO (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
;
(defun READYGO ()
   (setq LASTENT (entlast))
   (if (= LASTENT nil)
       (progn
           (command "LINE" "0,0" "1,0" "")
           (setq LASTENT (entlast))
       );progn
   );if
   (textscr)
   (princ "\n")
   (princ "\n")
   (princ "\n")
   (princ "\n")
   (princ "\nDraw any of these entities: Lines, Arcs, Circles, Text,")
   (princ "\nSolids, or Dimensioning can all be drawn using this routine.")
   (princ "\n")
   (princ "\n")
   (princ "\nAfter drawing the desired object(s) type MAKELISP at the command prompt.")
   (princ "\nYou will then be prompted for the name of the AutoLISP routine to be")
   (princ "\ncreated.")
   (princ "\n")
   (princ "\n")
   (princ "\n")
   (terpri)
);readygo
;
(defun DISTANG ()
   (setq NUMBER (distance PTCK1 PTCK2))
   (CKNUMBER)
   (setq DISTASCII NUMBERASCII)
   (setq NUMBER (angle PTCK1 PTCK2))
   (CKNUMBER)
   (setq ANGASCII NUMBERASCII)
);distang
;
(defun CKCOLLT ()
   (setq OLDENTLINETYPE ENTLINETYPE)
   (setq ENTLINETYPE nil)
   (setq OLDENTCOLOR ENTCOLOR)
   (setq ENTCOLOR nil)
   (cond ((cdr (assoc 6 STRIPENT)) (setq ENTLINETYPE (cdr (assoc 6 STRIPENT)))))
   (cond ((cdr (assoc 62 STRIPENT)) (setq ENTCOLOR (rtos (cdr (assoc 62 STRIPENT)) 2 0))))
   (if (/= ENTLAYER OLDLAYER)
       (progn 
           (setq WLINE (strcat "   (command "(chr 34)"LAYER"(chr 34)" "(chr 34)"M"(chr 34)" "(chr 34)ENTLAYER(chr 34)" "(chr 34)(chr 34)")"))
           (write-line WLINE F)
       );progn
   );if
);ckcollt
;
(defun WORKING ()
   (princ "\nI'm working now on the following entity type ")
   (princ ENTTYPE)
   (princ ".")
   (setq ENTLAYER (assoc 8 STRIPENT))
   (setq ENTLAYER (cdr ENTLAYER))
   (setq ENTPOINT (assoc 10 STRIPENT))
);working
;
(defun COLRLTYPE ()
   (if (/= ENTLINETYPE nil)
       (progn
           (setq WLINE (strcat "   (command "(chr 34)"CHANGE"(chr 34)" "(chr 34)"L"(chr 34)" "(chr 34)(chr 34)" "(chr 34)"P"(chr 34)" "))
           (setq WLINE (strcat WLINE(chr 34)"LT"(chr 34)" "(chr 34)ENTLINETYPE(chr 34)" "(chr 34)(chr 34)")"))
           (write-line WLINE F)
       );progn
   );if
   (if (/= ENTCOLOR nil)
       (progn
           (setq WLINE (strcat "   (command "(chr 34)"CHANGE"(chr 34)" "(chr 34)"L"(chr 34)" "(chr 34)(chr 34)" "(chr 34)"P"(chr 34)" "))
           (setq WLINE (strcat WLINE(chr 34)"C"(chr 34)" "(chr 34)ENTCOLOR(chr 34)" "(chr 34)(chr 34)")"))
           (write-line WLINE F)
       );progn
   );if
);colrltype
;
(defun ORIGNPT ()
   (setq P (+ P 1))
   (setq PTASCII (itoa P))
   (setq PTASCII (strcat "PT" PTASCII))
   (setq WLINE (strcat "   (setq "PTASCII" (polar "OLDPTASCII" "ANGASCII" "DISTASCII"))"))
   (write-line WLINE F)
);orignpt
;
(defun CKNUMBER ()
    (setq REALNUMBER (fix NUMBER))
    (setq REMNUMBER (- NUMBER REALNUMBER))
    (setq NUMBERASCII (rtos REALNUMBER 2 0))
    (if (and (> REMNUMBER 0) (< REMNUMBER 1))
        (progn
            (setq REMNUMBER (* REMNUMBER 1000))
            (setq REMNUMBER (fix REMNUMBER))
            (setq REMNUMBER (rtos REMNUMBER 2 0))
            (if (= REMNUMBER "0.000") (setq REMNUMBER "000"))
            (if (< (strlen REMNUMBER) 3) (setq REMNUMBER (strcat "0" REMNUMBER)))
            (setq NUMBERASCII (strcat NUMBERASCII "." REMNUMBER))
        );progn
        (progn
            (setq REMNUMBER (rtos REMNUMBER 2 3))
            (if (>= REALNUMBER 1) (setq NUMBERASCII (strcat NUMBERASCII "." (substr REMNUMBER 3 3))) (setq NUMBERASCII "0.00"))
        );progn
    );if
);cknumber
;
(defun C:MAKELISP ()
   (setq P 1)
   (setq PTCK2 nil)
   (setq OLDFILE nil)
   (setq ENTLINETYPE nil)
   (setq ENTCOLOR nil)
   (setq OLDLAYER (getvar "CLAYER"))
   (setq OLDNAMEASSIGNED nil)
   (setq FIRSTTIME 0)
   (textscr)
   (princ "\n")
   (princ "\n")
   (princ "\nEnter 8 Characters or Less for File Name for Your AutoLISP")
   (setq FNAME (getstring "\nMacro.  Do NOT include '.LSP' in File Name. : "))
   (setq FNAME (strcase FNAME))
   (setq LEN (strlen FNAME))
   (if (> LEN 8) 
       (progn
           (setq FNAME (getstring "\nFile Name is to long.  Please Try Again. "))
       );progn
   );if
   (setq TESTFILE (strcat FNAME ".LSP"))
   (setq OLDFILE (findfile TESTFILE))
   (if (/= OLDFILE nil)
       (progn
           (initget 1 "Y N")
           (princ "\nA File Name with the Name ")
           (princ OLDFILE)
           (princ " already exists.")
           (princ "\nDo you want to overwrite it? (Y or N) :")
           (setq INKEY (getkword))
           (if (= INKEY "Y")
               (progn
                   (setq F (open OLDFILE "w"))
                   (setq WLINE ";RE-WRITTEN FILE")
                   (write-line WLINE F)
                   (close F)
               );progn
           );if
           (if (= INKEY "N")
               (progn
                   (princ "\nEnter 8 Characters or Less for File Name for Your AutoLISP")
                   (setq FNAME (getstring "\nMacro.  Do NOT include '.LSP' in File Name. : "))
                   (setq FNAME (strcase FNAME))
               );progn
           );if
       );progn
   );if
   (setq NAMEF (strcat FNAME ".LSP"))
   (setq F (open NAMEF "a"))
   (setq WLINE ";This routine created using DOLISP.LSP")
   (write-line WLINE F)
   (setq WLINE ";Developed By: Perry H. Mason                                     11/20/89")
   (write-line WLINE F)
   (setq WLINE ";")
   (write-line WLINE F)
   (setq WLINE (strcat "(defun C:" FNAME " ()"))
   (write-line WLINE F)
   (setq WLINE (strcat "   (setq PT1 (getpoint "(chr 34)(chr 92)(chr 110)"Enter Insertion point:" (chr 34)"))"))
   (write-line WLINE F)
   (setq NEWLASTENT (entlast))
   (setq CONTINUEROUTINE 5)
   (setq PTASCII "PT1")
   (while (> CONTINUEROUTINE nil)
       (setq STRIPENT (entnext LASTENT))
       (setq STOPROUTINEENT STRIPENT)
       (setq STRIPENT (entget STRIPENT))
       (setq ENTTYPE (assoc 0 STRIPENT))
       (setq ENTTYPE (cdr ENTTYPE))
       (if (= ENTTYPE "LINE")
           (progn
               (WORKING)
               (CKCOLLT)
               (setq PTX1 (cadr ENTPOINT))
               (setq PTY1 (caddr ENTPOINT))
               (setq ENTPOINT (assoc 11 STRIPENT))
               (setq PTX2 (cadr ENTPOINT))
               (setq PTY2 (caddr ENTPOINT))
               (setq PTCK1 (list PTX1 PTY1))
               (setq PTCK2 (list PTX2 PTY2))
               (setq OLDPTASCII PTASCII)
               (if (not OLDPTCK2) (setq OLDPTCK2 PTCK1))
               (if (equal OLDPTCK2 PTCK1)
                   (progn
                       (DISTANG)
                       (ORIGNPT)
                       (setq WLINE (strcat "   (command "(chr 34)"LINE"(chr 34)" "OLDPTASCII" "PTASCII" "(chr 34)(chr 34)")"))
                       (write-line WLINE F)
                       (COLRLTYPE)
                       (setq OLDPTCK2 PTCK2)
                   );progn
                   (progn
                       (setq TEMPPTCK1 PTCK1)
                       (setq TEMPPTCK2 PTCK2)
                       (setq PTCK2 PTCK1)
                       (setq PTCK1 OLDPTCK2)
                       (DISTANG)
                       (setq PTCK2 TEMPPTCK2)
                       (setq PTCK1 TEMPPTCK1)
                       (ORIGNPT)
                       (setq OLDPTASCII PTASCII)
                       (DISTANG)
                       (ORIGNPT)
                       (setq WLINE (strcat "   (command "(chr 34)"LINE"(chr 34)" "OLDPTASCII" "PTASCII" "(chr 34)(chr 34)")"))
                       (write-line WLINE F)
                       (COLRLTYPE)
                       (setq OLDPTCK2 PTCK2)
                   );progn
               );if
               (if (equal NEWLASTENT STOPROUTINEENT) (setq CONTINUEROUTINE nil))
               (setq OLDLAYER ENTLAYER)
               (setq LASTENT STOPROUTINEENT)
           );progn
       );if
       (if (= ENTTYPE "SOLID")
           (progn
               (WORKING)
               (CKCOLLT)
               (setq PTCK1 (list (cadr ENTPOINT) (caddr ENTPOINT)))
               (setq TEMPPTCK1 PTCK1)
               (setq OLDPTASCII PTASCII)
               (if (not OLDPTCK2) (setq OLDPTCK2 PTCK1))
               (setq PTCK2 PTCK1)
               (setq PTCK1 OLDPTCK2)
               (DISTANG)
               (ORIGNPT)
               (setq SOLIDFIRSTPT PTASCII)
               (setq OLDPTASCII PTASCII)
               (setq PTCK1 PTCK2)
               (setq PTCK2 (list (cadr (assoc 11 STRIPENT)) (caddr (assoc 11 STRIPENT))))
               (DISTANG)
               (ORIGNPT)
               (setq SOLIDSECPT PTASCII)
               (setq OLDPTASCII PTASCII)
               (setq PTCK1 PTCK2)
               (setq PTCK2 (list (cadr (assoc 12 STRIPENT)) (caddr (assoc 12 STRIPENT))))
               (DISTANG)
               (ORIGNPT)
               (setq SOLIDTHIRDPT PTASCII)
               (setq OLDPTASCII PTASCII)
               (setq PTCK1 PTCK2)
               (setq PTCK2 (list (cadr (assoc 13 STRIPENT)) (caddr (assoc 13 STRIPENT))))               
               (DISTANG)
               (ORIGNPT)
               (setq SOLIDFORTHPT PTASCII)
               (setq OLDPTASCII PTASCII)
               (setq OLDPTCK2 PTCK2)
               (setq WLINE (strcat "   (command "(chr 34)"SOLID"(chr 34)" "SOLIDFIRSTPT" "SOLIDSECPT))
               (setq WLINE (strcat WLINE" "SOLIDTHIRDPT" "SOLIDFORTHPT" "(chr 34)(chr 34)")"))
               (write-line WLINE F)
               (COLRLTYPE)
               (if (equal NEWLASTENT STOPROUTINEENT) (SETQ CONTINUEROUTINE nil))
               (setq OLDLAYER ENTLAYER)
               (setq LASTENT STOPROUTINEENT)
           );progn
       );if
       (if (= ENTTYPE "ARC")
           (progn
               (WORKING)
               (CKCOLLT)
               (setq PTX1 (cadr ENTPOINT))
               (setq PTY1 (caddr ENTPOINT))
               (setq ENTRADIUS (assoc 40 STRIPENT))
               (setq STARTANG (assoc 50 STRIPENT))
               (setq STOPANG (assoc 51 STRIPENT))
               (setq ENTRADIUS (cdr ENTRADIUS))
               (setq NUMBER ENTRADIUS)
               (CKNUMBER)
               (setq RADIUSASCII NUMBERASCII)
               (setq ENTSTARTANG (cdr STARTANG))
               (setq ENTSTOPANG (cdr STOPANG))
               (setq PTCK1 (list PTX1 PTY1))
               (setq OLDPTASCII PTASCII)
               (setq TEMPPTCK1 PTCK1)
               (if (not OLDPTCK2) (setq OLDPTCK2 PTCK1))
               (setq PTCK1 OLDPTCK2)
               (setq PTCK2 TEMPPTCK1)
               (DISTANG)
               (setq PTCK1 TEMPPTCK1)
               (ORIGNPT)
               (setq NUMBER ENTSTARTANG)
               (CKNUMBER)
               (setq STARTANGASCII NUMBERASCII)
               (setq NUMBER ENTSTOPANG)
               (CKNUMBER)
               (setq STOPANGASCII NUMBERASCII)
               (setq WLINE (strcat "   (setq STARTPT (polar "PTASCII" "STARTANGASCII" "RADIUSASCII"))"))
               (write-line WLINE F)
               (setq WLINE (strcat "   (setq STOPPT (polar "PTASCII" "STOPANGASCII" "RADIUSASCII"))"))
               (write-line WLINE F)
               (setq WLINE (strcat "   (command "(chr 34)"ARC"(chr 34)" "(chr 34)"C"(chr 34)" "PTASCII" STARTPT STOPPT)"))
               (write-line WLINE F)
               (COLRLTYPE)
               (setq OLDPTCK2 PTCK1)
               (if (equal NEWLASTENT STOPROUTINEENT) (setq CONTINUEROUTINE nil))
               (setq OLDLAYER ENTLAYER)
               (setq LASTENT STOPROUTINEENT)
           );progn
       );if
       (if (= ENTTYPE "CIRCLE")
           (progn
               (WORKING)
               (CKCOLLT)
               (setq PTX1 (cadr ENTPOINT))
               (setq PTY1 (caddr ENTPOINT))
               (setq ENTRADIUS (assoc 40 STRIPENT))
               (setq ENTRADIUS (cdr ENTRADIUS))
               (setq NUMBER ENTRADIUS)
               (CKNUMBER)
               (setq RADIUSASCII NUMBERASCII)
               (setq PTCK1 (list PTX1 PTY1))
               (if (/= PTASCII nil) (setq OLDPTASCII PTASCII))
               (if (= OLDPTCK2 nil) (setq OLDPTCK2 PTCK1))
               (setq TEMPPTCK1 PTCK1)
               (setq TEMPPTCK2 PTCK2)
               (if (not OLDPTCK2) (setq OLDPTCK2 PTCK1))
               (setq PTCK1 OLDPTCK2)
               (setq PTCK2 TEMPPTCK1)
               (DISTANG)
               (setq PTCK1 TEMPPTCK1)
               (setq PTCK2 TEMPPTCK2)
               (ORIGNPT)
               (setq WLINE (strcat "   (command "(chr 34)"CIRCLE"(chr 34)" "PTASCII" "RADIUSASCII")"))
               (write-line WLINE F)
               (COLRLTYPE)
               (setq OLDPTCK2 PTCK1)
               (if (equal NEWLASTENT STOPROUTINEENT) (setq CONTINUEROUTINE nil))
               (setq OLDLAYER ENTLAYER)
               (setq LASTENT STOPROUTINEENT)
           );progn
       );if
       (if (= ENTTYPE "TEXT")
           (progn
               (WORKING)
               (setq PTX1 (cadr ENTPOINT))
               (setq PTY1 (caddr ENTPOINT))
               (setq PTCK1 (list PTX1 PTY1))
               (setq OLDPTASCII PTASCII)
               (setq TEXTSTRING (cdr (assoc 1 STRIPENT)))
               (setq STRINGLEN (strlen TEXTSTRING))
               (setq LASTSTRINGCHAR (substr TEXTSTRING STRINGLEN 1))
               (if (= LASTSTRINGCHAR (chr 34))
                   (progn
                       (setq TEXTSTRING (substr TEXTSTRING 1 (- STRINGLEN 1)))
                       (print "\n")
                       (princ "\nThis text string contained a quotation mark which was removed.")
                       (princ "\nYou will need to do a text edit command on this text string after")
                       (princ "\neach use of this macro is done to replace the text character to the")
                       (princ "\ndimensioning data that this macro creates.")
                   );progn
               );if
               (setq ROTATION (cdr (assoc 50 STRIPENT)))
               (setq NUMBER (/ (* ROTATION 180.0) pi))
               (CKNUMBER)
               (setq ROTATION NUMBERASCII)
               (setq TEXTHEIGHT (cdr (assoc 40 STRIPENT)))
               (setq NUMBER TEXTHEIGHT)
               (CKNUMBER)
               (setq TEXTHEIGHT NUMBERASCII)
               (setq WIDTHFACTOR (cdr (assoc 41 STRIPENT)))
               (setq NUMBER WIDTHFACTOR)
               (CKNUMBER)
               (setq WIDTHFACTOR NUMBERASCII)
               (setq OBLIQUING (cdr (assoc 51 STRIPENT)))
               (setq NUMBER OBLIQUING)
               (CKNUMBER)
               (setq OBLIQUING NUMBERASCII)
               (setq NAMEASSIGNED (cdr (assoc 7 STRIPENT)))
               (if (= "STANDARD" NAMEASSIGNED) (setq TEXTSTYLE "TXT") (setq TEXTSTYLE NAMEASSIGNED))
               (if (= TEXTTEST 0) (setq PTCK2 (list PTX1 PTY1)))
               (if (> TEXTTEST 0) (setq PTCK2 (list ALIGNMENTX ALIGNMENTY)))
               (setq JUSTIFICATION (cdr (assoc 72 STRIPENT)))
               (if (= JUSTIFICATION 0)
                   (progn
                       (setq PTCK1 (list PTX1 PTY1))
                       (setq ACTUAL "L")
                   );progn
               );if
               (if (= JUSTIFICATION 1)
                   (progn
                       (setq ALIGNMENT (assoc 11 STRIPENT))
                       (setq ALIGNMENTX (cadr ALIGNMENT))
                       (setq ALIGNMENTY (caddr ALIGNMENT))
                       (setq PTCK1 (list ALIGNMENTX ALIGNMENTY))
                       (setq ACTUAL "C")
                   );progn
               );if
               (if (= JUSTIFICATION 2)
                   (progn
                       (setq ALIGNMENT (assoc 11 STRIPENT))
                       (setq ALIGNMENTX (cadr ALIGNMENT))
                       (setq ALIGNMENTY (caddr ALIGNMENT))
                       (setq PTCK1 (list ALIGNMENTX ALIGNMENTY))
                       (setq ACTUAL "R")
                   );progn
               );if
               (if (= JUSTIFICATION 5) (setq ACTUAL "F"))
               (setq OLDPTASCII PTASCII)
               (setq TEMPPTCK1 PTCK1)
               (setq TEMPPTCK2 PTCK2)
               (setq PTCK2 PTCK1)
               (if (not OLDPTCK2) (setq OLDPTCK2 PTCK1))
               (setq PTCK1 OLDPTCK2)
               (DISTANG)
               (ORIGNPT)
               (setq PTCK1 TEMPPTCK1)
               (setq PTCK2 TEMPPTCK2)
               (setq OLDPTASCII PTASCII)
               (if (/= OLDNAMEASSIGNED NAMEASSIGNED)
                   (progn
                       (setq WLINE (strcat "   (command "(chr 34)"STYLE"(chr 34)" "(chr 34)NAMEASSIGNED(chr 34)" "(chr 34)TEXTSTYLE(chr 34)" 0.0 "WIDTHFACTOR" "OBLIQUING" "))
                       (setq WLINE (strcat WLINE(chr 34)"N"(chr 34)" "(chr 34)"N"(chr 34)" "(chr 34)"N"(chr 34)")"))
                       (write-line WLINE F)
                       (setq OLDNAMEASSIGNED NAMEASSIGNED)
                   );progn
               );if
               (CKCOLLT)
               (if (= ACTUAL "L")
                   (progn
                       (setq WLINE (strcat "   (command "(chr 34)"TEXT"(chr 34)" "OLDPTASCII" "TEXTHEIGHT" "ROTATION" "(chr 34)TEXTSTRING(chr 34)")"))
                       (write-line WLINE F)
                   );progn
               );if
               (if (or (= ACTUAL "C") (= ACTUAL "R"))
                   (progn
                       (setq WLINE (strcat "   (command "(chr 34)"TEXT"(chr 34)" "(chr 34)ACTUAL(chr 34)" "OLDPTASCII" "TEXTHEIGHT" "ROTATION" "(chr 34)TEXTSTRING(chr 34)")"))
                       (write-line WLINE F)
                   );progn
               );if
               (if (= ACTUAL "F")
                   (progn
                       (setq STARTPT OLDPTASCII)
                       (setq ALIGNMENTX (cadr (assoc 11 STRIPENT)))
                       (setq PTCK2 (list ALIGNMENTX PTY1))
                       (setq OLDPTASCII PTASCII)
                       (DISTANG)
                       (ORIGNPT)
                       (setq ENDPT PTASCII)
                       (setq PTCK2 TEMPPTCK2)
                       (setq WLINE (strcat "   (command "(chr 34)"TEXT"(chr 34)" "(chr 34)ACTUAL(chr 34)" "STARTPT" "ENDPT" "TEXTHEIGHT" "(chr 34)TEXTSTRING(chr 34)")"))
                       (write-line WLINE F)
                   );progn
               );if
               (COLRLTYPE)
               (setq OLDPTCK2 PTCK1)
               (if (equal NEWLASTENT STOPROUTINEENT) (setq CONTINUEROUTINE nil))
               (setq OLDLAYER ENTLAYER)
               (setq LASTENT STOPROUTINEENT)
           );progn
       );if
    );while
    (if (/= (getvar "CLAYER") "0")
        (progn
            (setq WLINE (strcat "   (command "(chr 34)"LAYER"(chr 34)" "(chr 34)"S"(chr 34)" "(chr 34)OLDLAYER(chr 34)" "(chr 34)(chr 34)")"))
            (write-line WLINE F)
        );progn
    );if
    (if (/= (getvar "TEXTSTYLE") "STANDARD")
        (progn
            (setq WLINE (strcat "   (command "(chr 34)"STYLE"(chr 34)" "(chr 34)"STANDARD"(chr 34)" "(chr 34)(chr 34)" "(chr 34)(chr 34)" "))
            (setq WLINE (strcat WLINE(chr 34)(chr 34)" "(chr 34)(chr 34)" "(chr 34)(chr 34)" "(chr 34)(chr 34)" "(chr 34)(chr 34)")"))
            (write-line WLINE F)
        );progn
    );if
    (setq FNAME (strcase FNAME T))
    (setq WLINE (strcat ");" FNAME))
    (write-line WLINE F)
    (close F)
    (princ "\n")
    (princ "\nYou can now redraw the previously drawn item(s) into any drawing simply by")
    (princ "\nusing the AutoCAD command LOAD, see the AutoCAD Users manual for format, to")
    (princ "\nload ")
    (setq FNAME (strcase FNAME))
    (princ FNAME)
    (princ ".LSP which is the files name that you just created.")
    (terpri)
    (setvar "CMDECHO" OLDECHO)
);makelisp
;
(readygo)
